# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.kz> 
"""
$Id: ForumCatalog.py,v 1.5 2004/02/12 12:45:16 fafhrd91 Exp $
"""

from Acquisition import aq_base
from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from Products.CMFCore.CatalogTool import CatalogTool
from Products.CMFCore.CMFCorePermissions import View, ManagePortal

class ForumCatalog(CatalogTool):
    """ """
    meta_type = 'ForumCatalog'

    id = 'forum_catalog'

    security = ClassSecurityInfo()

    security.declarePublic( 'enumerateIndexes' )
    def enumerateIndexes( self ):
        return ( ('id', 'FieldIndex'),
                 ('title', 'FieldIndex'),
                 ('Creator', 'FieldIndex'),
                 ('created', 'DateIndex'),
                 ('modified', 'DateIndex'),
                 ('allowedRolesAndUsers', 'KeywordIndex'),
                 ('review_state', 'FieldIndex'),
                 ('topic_type', 'FieldIndex'),
                 ('sticky_flag', 'FieldIndex'),
                 )
    
    security.declarePublic( 'enumerateColumns' )
    def enumerateColumns( self ):
        return ( 'sticky_flag',
                 'description',
                 'modified',
                 'Creator',
                 'title',
                 'review_state',
                 'replyCount',
                 )

    def _listAllowedRolesAndUsers( self, user ):
        # Makes sure the list includes the user's groups
        result = list( user.getRoles() )
        if hasattr(aq_base(user), 'getGroups'):
            result = result + ['user:%s' % x for x in user.getGroups()]
        result.append( 'Anonymous' )
        result.append( 'user:%s' % user.getId() )
        return result

InitializeClass(ForumCatalog)


def addForumCatalog(self):
    ob = ForumCatalog()
    self._setObject(ob.getId(), ob)

    return ob
