# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz>
"""
$Id: ForumMailTemplates.py,v 1.12 2004/04/30 06:44:38 fafhrd91 Exp $
"""

forum_message_plain = {'title':'Forum Message (plain)',
                       'mail_subject': 'string:${options/message_title}',
                       'mail_body':
"""<tal:block content="structure options/message_body" /><tal:block i18n:domain="CMFBoard" i18n:translate="text_message_plain">

original: <tal:block content="options/message_url" i18n:name="message_url" />
_____________________________
"<tal:block i18n:name="forum_title" content="options/forum_title"/>" <tal:block content="options/forum_url" i18n:name="forum_url" />
"<tal:block i18n:name="portal_title" content="options/portal_title"/>" <tal:block content="options/portal_url" i18n:name="portal_url" />
</tal:block>
"""}


forum_message_html = {'title':'Forum Message (html)',
                      'mail_subject': 'string:${options/message_title}',
                      'mail_body':
"""<tal:block i18n:domain="CMFBoard" i18n:translate="text_message_html"><div tal:content="structure options/message_body" i18n:name="message_body" />
<br />
<br />
<a tal:attributes="href options/message_url">original</a><br />
_____________________________<br />
<a i18n:name="forum_title" tal:attributes="href options/forum_url" tal:content="options/forum_title"></a><br />
<a i18n:name="portal_title" tal:attributes="href options/portal_url" tal:content="options/portal_title"></a><br />
</tal:block>
"""}


forum_moderated_message = {'title': 'Moderated message',
                           'mail_subject': "python:here.translate('text_your_message',default='Your message to') + options['forum_title'] + here.translate('text_awaits_approval', defaul='awaits moderator approval.')",
                           'mail_body':
"""<tal:block i18n:domain="CMFBoard" i18n:translate="text_moderated_message">
Your message to '<tal:block i18n:name="forum_title" content="options/forum_title"/>' with the subject

    <tal:block i18n:name="message_title" content="options/message_title"/>

Is being held until the review moderator can review it for approval.


original: <tal:block i18n:name="mesage_url" content="options/message_url"/>
_____________________________
"<tal:block i18n:name="forum_title" content="options/forum_title"/>" <tal:block content="options/forum_url" i18n:name="forum_url" />
"<tal:block i18n:name="portal_title" content="options/portal_title"/>" <tal:block content="options/portal_url" i18n:name="portal_url" />
</tal:block>
"""}


forum_error_1 = {'title': 'Error 1',
                 'description': "User don't have permission to add new topic.",
                 'mail_subject': "python:here.translate('error_perm_add_topic', default='Error (Add new topic)')",
                 'mail_body':
"""<tal:block i18n:domain="CMFBoard" i18n:translate="text_error_1">

You don't have permission to add a new topic.

_____________________________
"<tal:block i18n:name="forum_title" content="options/forum_title"/>" <tal:block content="options/forum_url" i18n:name="forum_url" />
"<tal:block i18n:name="portal_title" content="options/portal_title"/>" <tal:block content="options/portal_url" i18n:name="portal_url" />
</tal:block>
"""}

forum_error_2 = {'title': 'Error 2',
                 'description': "User are not subscribed.",
                 'mail_subject': "python:here.translate('error_not_subscribed', default='Error (Not Subscribed)')",
                 'mail_body':
"""<tal:block i18n:domain="CMFBoard" i18n:translate="text_error_2">

You are not subscribed.
To subscribe, please visit forum.
"<tal:block i18n:name="forum_url" content="options/forum_url"/>": <tal:block content="options/forum_title" i18n:name="forum_title" />

_____________________________
"<tal:block i18n:name="portal_title" content="options/portal_title"/>" <tal:block content="options/portal_url" i18n:name="portal_url" />
</tal:block>
"""}


forum_error_3 = {'title': 'Error 3',
                 'description': "Topic not found.",
                 'mail_subject': "python:here.translate('error_topic_not_found', default='Error (Topic not found)')",
                 'mail_body':
"""<tal:block i18n:domain="CMFBoard" i18n:translate="text_error_3">

The topic you are replying to cannot be found.
It may have been removed.

_____________________________
"<tal:block i18n:name="forum_title" content="options/forum_title"/>" <tal:block content="options/forum_url" i18n:name="forum_url" />
"<tal:block i18n:name="portal_title" content="options/portal_title"/>" <tal:block content="options/portal_url" i18n:name="portal_url" />
</tal:block>
"""}


forum_error_4 = {'title': 'Error 4',
                 'description': "User don't have permission to add reply.",
                 'mail_subject': "python:here.translate('error_perm_add_new_reply',default='Error (Add new reply)')",
                 'mail_body':
"""<tal:block i18n:domain="CMFBoard" i18n:translate="text_error_4">

You don't have permission to add a new reply.

_____________________________
"<tal:block i18n:name="forum_title" content="options/forum_title"/>" <tal:block content="options/forum_url" i18n:name="forum_url" />
"<tal:block i18n:name="portal_title" content="options/portal_title"/>" <tal:block content="options/portal_url" i18n:name="portal_url" />
</tal:block>
"""}


templates = {
    'CMFBoard':
    {'attributes': {'title':'CMFBoard mail templates',
                    'fields':[],},
     'templates': {'forum_message_plain': forum_message_plain,
                   'forum_message_html': forum_message_html,
                   'forum_moderated_message': forum_moderated_message,
                   'forum_error_1': forum_error_1,
                   'forum_error_2': forum_error_2,
                   'forum_error_3': forum_error_3,
                   'forum_error_4': forum_error_4,
                   }
     }
    }
