# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz>
"""
$Id: SizeValidator.py,v 1.7 2004/03/29 12:45:35 fafhrd91 Exp $
"""

from Products.Archetypes.public import *
from Products.validation import validation
from Products.validation.interfaces import ivalidator

mapping = {
    'checkImageSize': 'image_size',
    'checkFileSize': 'file_size',
    'checkTextSize': 'text_size',
    }

class SizeValidator:
    __implements__ = (ivalidator,)
    
    def __init__(self, name):
        self.name = name
        
    def __call__(self, value, *args, **kwargs):
        inst = kwargs['instance']

        forum = inst.getForum()
        size = forum.getField(mapping[self.name]).get(forum)

        try:
            if ((hasattr(value, 'filename') and (size < len(value.read()))) or
                (size < len(value))):
                try:
                    value.seek(0)
                except:
                    pass
                return 'Max size exceeded.'
        except:
            pass
        
        return 1

validation.register(SizeValidator('checkImageSize'))
validation.register(SizeValidator('checkFileSize'))
validation.register(SizeValidator('checkTextSize'))
