#
# Tests the Forum Folder
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.CMFBoard.tests.BoardTestCase import *

from Acquisition import aq_base
from AccessControl.SecurityManagement import \
     newSecurityManager, noSecurityManager

forums_tree = [
    {'url': 'http://nohost/portal/forums', 'disable': 0, 'title': ' Discussion Forums'},
    {'url': 'http://nohost/portal/forums/public', 'disable': 1,
     'title': '-- Public Test Forum'},
    {'url': 'http://nohost/portal/forums/members', 'disable': 1,
     'title': '-- Member Test Forum'},
    {'url': 'http://nohost/portal/forums/test_forum', 'disable': 1,'title': '-- title'},
    {'url': 'http://nohost/portal/forums/forums', 'disable': 0, 'title': '- title'},
    {'url': 'http://nohost/portal/forums/forums/public', 'disable': 1,
     'title': '---- Public Test Forum'},
    {'url': 'http://nohost/portal/forums/forums/members', 'disable': 1,
     'title': '---- Member Test Forum'}]

members_tree = [
    {'url': 'http://nohost/portal/forums', 'disable': 0, 'title': ' Discussion Forums'},
    {'url': 'http://nohost/portal/forums/public', 'disable': 1,
     'title': '-- Public Test Forum'},
    {'url': 'http://nohost/portal/forums/test_forum', 'disable': 1, 'title': '-- title'},
    {'url': 'http://nohost/portal/forums/forums', 'disable': 0, 'title': '- title'},
    {'url': 'http://nohost/portal/forums/forums/public', 'disable': 1,
     'title': '---- Public Test Forum'}]


class TestForumFolder(BoardTestCase):
    def testAddNewForum(self):
        self.loginPortalOwner()
        self.portal.forums.invokeFactory('ForumNB', 'test_forum', title='title')

    def testAddNewForumFolder(self):
        self.loginPortalOwner()
        self.portal.forums.invokeFactory('ForumFolder', 'forums', title='title')

    def testForumsTreeOwner(self):
        self.loginPortalOwner()
        forums = self.getPortal().forums

        forums.invokeFactory('ForumNB', 'test_forum', title='title')
        forums.invokeFactory('ForumFolder', 'forums', title='title')
        self.assertEquals(forums_tree==forums.forum_get_forums_tree(),True)
        self.assertEquals(forums_tree==forums.forums.forum_get_forums_tree(),True)

    def testForumsTreeAnonymous(self):
        self.loginPortalOwner()
        forums = self.getPortal().forums
        forums.invokeFactory('ForumNB', 'test_forum', title='title')
        forums.invokeFactory('ForumFolder', 'forums', title='title')
        noSecurityManager()
        self.assertEquals(members_tree==forums.forum_get_forums_tree(),True)
        self.assertEquals(members_tree==forums.forums.forum_get_forums_tree(),True)

    def testForumFolderCreationDefault(self):
        self.loginPortalOwner()
        portal = self.getPortal()
        wtool = portal.portal_workflow

        portal.invokeFactory('ForumFolder', 'test_forums', title='Test forums')
        test_forums = portal.test_forums
        self.assertEquals(test_forums.getPortalTypeName()=='ForumFolder',True)
        self.assertEquals(
            wtool.getInfoFor(test_forums.members,'review_state'),'members')
        self.assertEquals(
            wtool.getInfoFor(test_forums.public,'review_state'),'public1')
        
if __name__ == '__main__':
    framework()
else:
    import unittest
    def test_suite():
        suite = unittest.TestSuite()
        suite.addTest(unittest.makeSuite(TestForumFolder))
        return suite
