#
# Tests the Forum Folder
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.CMFBoard.tests.BoardTestCase import *

from Acquisition import aq_base
from AccessControl.SecurityManagement import \
     newSecurityManager, noSecurityManager

class TestForumWorkflow(BoardTestCase):
    def afterSetUp(self):
        self.catalog = self.portal.portal_catalog
        self.workflow = self.portal.portal_workflow

        self.portal.acl_users._doAddUser('member', 'secret', ['Member'], [])
        self.portal.acl_users._doAddUser('reviewer', 'secret', ['Reviewer'], [])
        self.portal.acl_users._doAddUser('manager', 'secret', ['Manager'], [])

        self.forum = self.getPortal().forums.members

    def testOwnerMakePublic1(self):
        self.loginPortalOwner()
        self.assertEqual(self.workflow.getInfoFor(self.forum, 'review_state'), 'members')
        self.workflow.doActionFor(self.forum, 'public1')
        self.assertEqual(self.workflow.getInfoFor(self.forum, 'review_state'), 'public1')
        self.failUnless(self.catalog(id='members', review_state='public1'))

    def testOwnerMakePublic2(self):
        self.loginPortalOwner()
        self.assertEqual(self.workflow.getInfoFor(self.forum, 'review_state'), 'members')
        self.workflow.doActionFor(self.forum, 'public2')
        self.assertEqual(self.workflow.getInfoFor(self.forum, 'review_state'), 'public2')
        self.failUnless(self.catalog(id='members', review_state='public2'))

    def testOwnerMakeCustom(self):
        self.loginPortalOwner()
        self.assertEqual(self.workflow.getInfoFor(self.forum, 'review_state'), 'members')
        self.workflow.doActionFor(self.forum, 'custom')
        self.assertEqual(self.workflow.getInfoFor(self.forum, 'review_state'), 'custom')
        self.failUnless(self.catalog(id='members', review_state='custom'))

    def testOwnerMakeMembers(self):
        self.loginPortalOwner()
        forum = self.portal.forums.public
        
        self.assertEqual(self.workflow.getInfoFor(forum, 'review_state'), 'public1')
        self.workflow.doActionFor(forum, 'members')
        self.assertEqual(self.workflow.getInfoFor(forum, 'review_state'), 'members')
        self.failUnless(self.catalog(id='members', review_state='members'))

        
if __name__ == '__main__':
    framework()
else:
    import unittest
    def test_suite():
        suite = unittest.TestSuite()
        suite.addTest(unittest.makeSuite(TestForumWorkflow))
        return suite
