#
# Tests the CMFBoard installation
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.CMFBoard.tests.BoardTestCase import *

from Acquisition import aq_base
from AccessControl.SecurityManagement import \
     newSecurityManager, noSecurityManager

class TestInstallation(BoardTestCase):
    def testInstalledLeftSlots(self):
        portal = self.getPortal()
        left_slots = portal.left_slots

        self.assertEquals(
            'here/forumRejected_slot/macros/rejectedBox' in left_slots, True)
        self.assertEquals(
            'here/forumSubmitted_slot/macros/submittedBox' in left_slots, True)

    def testInstalledTypes(self):
        portal = self.getPortal()
        ttool = portal.portal_types

        for tp in ['ForumNB', 'ForumTopic', 'ForumMessage', 'ForumPoll',
                   'ForumContentTopic', 'ForumFolder']:
            self.assertEquals(tp is not None, True)

if __name__ == '__main__':
    framework()
else:
    import unittest
    def test_suite():
        suite = unittest.TestSuite()
        suite.addTest(unittest.makeSuite(TestInstallation))
        return suite
