# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nikolay Kim <fafhrd@legco.biz> 

from types import StringType

def opt_localized_time(time, trans):
    if type(trans) == StringType:
        return time.strftime(trans)
   
    dateParts = time.parts()
    day = '%02d' % dateParts[2]
    month = '%02d' % dateParts[1]
    year = dateParts[0]
    hour = '%02d' % dateParts[3]
    minute = '%02d' % dateParts[4]

    # substitute variables with actual values
    localized_time = trans.replace('${DAY}', str(day))
    localized_time = localized_time.replace('${MONTH}', str(month))
    localized_time = localized_time.replace('${YEAR}', str(year))
    localized_time = localized_time.replace('${HOUR}', str(hour))
    localized_time = localized_time.replace('${MINUTE}', str(minute))

    return localized_time


def get_message_icon(msg, msg_uid, cache, portal, forum, default='&nbsp;'):
    msg_icon = None

    if cache is not None:
        msg_icon = cache.ZCache_get(portal, 'message_icon', keywords={'UID': msg_uid})
        if msg_icon is not None:
            if msg_icon:
                return msg_icon
            else:
                return default

    try:
        msg_icon = getattr(msg, 'message_icon')
        msg_icon = getattr(forum.fcIcons, msg_icon).tag()
    except:
        msg_icon = ''

    if cache is not None:
        cache.ZCache_set(portal, msg_icon, 'message_icon', keywords={'UID': msg_uid})

    return msg_icon or default
